000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB RES RENT                 
000200 PROCESS AWO NOSEQ                                                        
000300 ID DIVISION.                                                             
000400* LAST UPDATE ON 17 Feb 1995 AT 10:37:11 BY  VEND789 VERSION 01   *       
000500 PROGRAM-ID. AFPREBLK.                                                    
000600 AUTHOR. H. Turetzky, HYDRA                                               
000700     This program reblocks an AFPDS file into fixed 80-byte               
000800     records for transmission to a PC or AIX system, and                  
000900     reblocks a stream file transmitted from a PC or AIX                  
001000     system (in binary mode) to VSE as individual variable-               
001100     length records suitable for printing.                                
001200                                                                          
001300     All input data is assumed to be AFPDS structured fields              
001400     with a x'5A' control character appended to the beginning.            
001500                                                                          
001600     Using AFPREBLK:                                                      
001700     The program is controlled by a parm designating the direction        
001800     of the conversion. To reblock AFPDS for transmission to the          
001900     PC, use PARM='AFP2PC'. The input file will be SYS001, DLBL           
002000     AFPVBIN, a variable-length blocked file. The output will be          
002100     SYS002, DLBL AFPPCOT, a fixed-blocked 80 byte file.                  
002200                                                                          
002300     To reblock for printing on VSE, use PARM='PC2AFP', input file        
002400     SYS003, DLBL AFPPCIN, an 80-byte blocked file, and output file       
002500     SYS004, DLBL AFPVBOT, variable length blocked.                       
002600                                                                          
002700     To print directly to the Power spool, use PARM='PC2PRT',             
002800     input file SYS003, DLBL AFPPCIN, an 80-byte blocked file, and        
002900     output file SYS005, assigned to a Power printer.                     
003000                                                                          
003100     To transfer a reblocked file from VSE to a PC, copy the output       
003200     of this program (AFP2PC, file AFPPCOT) to the POWER spool            
003300     queue, then use ICCF (or another file tranfer program) to            
003400     download from the spool to the PC.                                   
003500                                                                          
003600     To transfer a file from the PC to VSE, use ICCF option 386           
003700     with the sendfile command:                                           
003800         SEND file A:file (BINARY LRECL=80 NOCRLF                         
003900     where file is the PC filename and A:file is the terminal             
004000     emulator session and the spool file name.  ICCF option 385           
004100     may be used to then transfer the file to an ICCF library,            
004200     where it can be then saved to a SAM file (use DITTO or               
004300     IDCAMS REPRO).                                                       
004400                                                                          
004500          NOTE: REQUIRES COBOL II 3.3 OR LATER WITH APAR                  
004600          PN64949 TO COMPILE AND PRINT TO POWER.                          
004601*                                                                         
004610*  Change History                                                         
004620*  01A    24May96  HLT   incorrect length writing to spool                
004630*                        per Stanley M Ehrke                              
004700     EJECT                                                                
004800 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                            
004900 DATE-WRITTEN. Aug 94.                                                    
005000 DATE-COMPILED.                                                           
005100 SECURITY. IBM SAMPLE CODE ONLY.                                          
005200*/**************************************************************/         
005300*/*   (C) COPYRIGHT IBM CORPORATION, 1994                      */         
005400*/*                                                            */         
005500*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */         
005600*/*                                                            */         
005700*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */         
005800*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */         
005900*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */         
006000*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */         
006100*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */         
006200*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */         
006300*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */         
006400*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */         
006500*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */         
006600*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */         
006700*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */         
006800*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */         
006900*/**************************************************************/         
007000 TITLE 'AFP REBLOCKING PROGRAM'.                                          
007100 ENVIRONMENT DIVISION.                                                    
007200 CONFIGURATION SECTION.                                                   
007300 SOURCE-COMPUTER. IBM-370.                                                
007400 OBJECT-COMPUTER. IBM-370.                                                
007500 SPECIAL-NAMES.                                                           
007600     AFP-5A IS AFP-5A.                                                    
007700 INPUT-OUTPUT SECTION.                                                    
007800 FILE-CONTROL.                                                            
007900     SELECT AFPREBLK-AFP-IN      ASSIGN TO SYS001-S-AFPVBIN               
008000                                 FILE STATUS                              
008100                                 AFPREBLK-AFP-IN-STATUS.                  
008200     SELECT AFPREBLK-PC-OUT      ASSIGN TO SYS002-S-AFPPCOT               
008300                                 FILE STATUS                              
008400                                 AFPREBLK-PC-OUT-STATUS.                  
008500     SELECT AFPREBLK-PC-IN       ASSIGN TO SYS003-S-AFPPCIN               
008600                                 FILE STATUS                              
008700                                 AFPREBLK-PC-IN-STATUS.                   
008800     SELECT AFPREBLK-AFP-OUT     ASSIGN TO SYS004-S-AFPVBOT               
008900                                 FILE STATUS                              
009000                                 AFPREBLK-AFP-OUT-STATUS.                 
009100     SELECT AFPREBLK-AFP-PRT     ASSIGN TO SYS005-AFPPRT                  
009200                                 FILE STATUS                              
009300                                 AFPREBLK-AFP-PRT-STATUS.                 
009400   EJECT                                                                  
009500 DATA DIVISION.                                                           
009600 FILE SECTION.                                                            
009700 FD  AFPREBLK-AFP-IN             GLOBAL,                                  
009800     BLOCK CONTAINS 0 RECORDS,                                            
009900     RECORDING MODE IS V                                                  
010000     RECORD VARYING FROM 09 TO 32752 DEPENDING ON AFPREBLK-LENGTH.        
010100                                                                          
010200 01  AFPREBLK-AFP-IN-RECORD.                                              
010300     05  AFPREBLK-AFP-IN-INTRODUCER.                                      
010400       10  AFPREBLK-AFP-IN-CC      PIC X.                                 
010500       10  AFPREBLK-AFP-IN-LEN-CHR PIC XX.                                
010600       10  AFPREBLK-AFP-IN-RECLEN  REDEFINES                              
010700                                   AFPREBLK-AFP-IN-LEN-CHR                
010800                                   PIC 9(4) COMP.                         
010900* NOTE:  9(4) COMP is used to get halfword integer, but COBOL             
011000* may restrict value to 9999. COBOL II compile-time parm                  
011100* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword             
011200* with no truncation (TRUNC(OPT) produces far better code).               
011300       10  AFPREBLK-AFP-IN-TYPE    PIC XXX.                               
011400       10  AFPREBLK-AFP-IN-FLAG    PIC X.                                 
011500       10  AFPREBLK-AFP-IN-SEQ-CHR PIC XX.                                
011600       10  AFPREBLK-AFP-IN-SEQNUM  REDEFINES                              
011700                                   AFPREBLK-AFP-IN-SEQ-CHR                
011800                                   PIC 9(4) COMP.                         
011900     05  AFPREBLK-AFP-IN-DATA.                                            
012000         10  AFPREBLK-AFP-IN-ARRAY                                        
012100                                   OCCURS 32743,                          
012200                                   DEPENDING ON                           
012300                                   AFPREBLK-AFP-IN-RECLEN,                
012400                                   INDEXED BY AFPREBLK-AFP-IN-INDX,       
012500                                   PIC X.                                 
012600   SKIP3                                                                  
012700 FD  AFPREBLK-AFP-OUT            GLOBAL,                                  
012800     BLOCK CONTAINS 32760 CHARACTERS,                                     
012900     RECORDING MODE IS V                                                  
013000     RECORD VARYING FROM 09 TO 32752 DEPENDING ON AFPREBLK-LENGTH.        
013100                                                                          
013200 01  AFPREBLK-AFP-OUT-RECORD.                                             
013300     05  AFPREBLK-AFP-OUT-INTRODUCER.                                     
013400       10  AFPREBLK-AFP-OUT-CC      PIC X.                                
013500       10  AFPREBLK-AFP-OUT-LEN-CHR PIC XX.                               
013600       10  AFPREBLK-AFP-OUT-RECLEN  REDEFINES                             
013700                                    AFPREBLK-AFP-OUT-LEN-CHR              
013800                                    PIC 9(4) COMP.                        
013900* NOTE:  9(4) COMP is used to get halfword integer, but COBOL             
014000* may restrict value to 9999. COBOL II compile-time parm                  
014100* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword             
014200* with no truncation (TRUNC(OPT) produces far better code).               
014300       10  AFPREBLK-AFP-OUT-TYPE    PIC XXX.                              
014400       10  AFPREBLK-AFP-OUT-FLAG    PIC X.                                
014500       10  AFPREBLK-AFP-OUT-SEQ-CHR PIC XX.                               
014600       10  AFPREBLK-AFP-OUT-SEQNUM  REDEFINES                             
014700                                    AFPREBLK-AFP-OUT-SEQ-CHR              
014800                                    PIC 9(4) COMP.                        
014900     05  AFPREBLK-AFP-OUT-DATA.                                           
015000         10  AFPREBLK-AFP-OUT-ARRAY                                       
015100                                    OCCURS 32743,                         
015200                                    DEPENDING ON                          
015300                                    AFPREBLK-AFP-OUT-RECLEN,              
015400                                    INDEXED BY                            
015500                                    AFPREBLK-AFP-OUT-INDX,                
015600                                    PIC X.                                
015700   SKIP3                                                                  
015800 FD  AFPREBLK-PC-IN              GLOBAL,                                  
015900     BLOCK CONTAINS 0 RECORDS,                                            
016000     RECORDING MODE IS F                                                  
016100     RECORD CONTAINS 80 CHARACTERS.                                       
016200                                                                          
016300 01  AFPREBLK-PC-IN-RECORD       PIC X(80).                               
016400   SKIP3                                                                  
016500 FD  AFPREBLK-PC-OUT             GLOBAL,                                  
016600     BLOCK CONTAINS 10 RECORDS,                                           
016700     RECORDING MODE IS F                                                  
016800     RECORD CONTAINS 80 CHARACTERS.                                       
016900                                                                          
017000 01  AFPREBLK-PC-OUT-RECORD      PIC X(80).                               
017100   SKIP3                                                                  
017200 FD  AFPREBLK-AFP-PRT            GLOBAL,                                  
017300     RECORDING MODE IS V                                                  
017400     RECORD VARYING FROM 09 TO 32750 DEPENDING ON AFPREBLK-LENGTH.        
017500                                                                          
017600 01  AFPREBLK-AFP-PRT-RECORD.                                             
017700     05  AFPREBLK-AFP-PRT-INTRODUCER.                                     
017800* The following line removed because after advancing adds an              
017900* extra byte for carriage control at the front of the record.             
018000       10  AFPREBLK-AFP-PRT-CC      PIC X.                                
018100       10  AFPREBLK-AFP-PRT-LEN-CHR PIC XX.                               
018200       10  AFPREBLK-AFP-PRT-RECLEN  REDEFINES                             
018300                                    AFPREBLK-AFP-PRT-LEN-CHR              
018400                                    PIC 9(4) COMP.                        
018500* NOTE:  9(4) COMP is used to get halfword integer, but COBOL             
018600* may restrict value to 9999. COBOL II compile-time parm                  
018700* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword             
018800* with no truncation (TRUNC(OPT) produces far better code).               
018900       10  AFPREBLK-AFP-PRT-TYPE    PIC XXX.                              
019000       10  AFPREBLK-AFP-PRT-FLAG    PIC X.                                
019100       10  AFPREBLK-AFP-PRT-SEQ-CHR PIC XX.                               
019200       10  AFPREBLK-AFP-PRT-SEQNUM  REDEFINES                             
019300                                    AFPREBLK-AFP-PRT-SEQ-CHR              
019400                                    PIC 9(4) COMP.                        
019500     05  AFPREBLK-AFP-PRT-DATA.                                           
019600         10  AFPREBLK-AFP-PRT-ARRAY                                       
019700                                    OCCURS 32741,                         
019800                                    DEPENDING ON                          
019900                                    AFPREBLK-AFP-PRT-RECLEN,              
020000                                    INDEXED BY                            
020100                                    AFPREBLK-AFP-PRT-INDX,                
020200                                    PIC X.                                
020300   EJECT                                                                  
020400 WORKING-STORAGE SECTION.                                                 
020500 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.                   
020600 77  ABEND-CODE              PIC 9(4) COMP VALUE 12.                      
020700 77  GET-OUTREC              PIC X(12) VALUE 'GET-OUTREC'.                
020800 77  GET-PC-IN               PIC X(12) VALUE 'GET-PC-IN'.                 
020900 77  MAXBUF                  PIC 9(4) BINARY VALUE 80.                    
021000 77  BUFMAX                  PIC 9(4) BINARY.                             
021100     SKIP2                                                                
021200 01  GLOBAL-VARIABLES            GLOBAL.                                  
021300     05  PGMNAME             PIC X(8) VALUE 'AFPREBLK'.                   
021400     05  AFPREBLK-LENGTH     PIC 9(8) COMP.                               
021500     05  INREC-COUNT         PIC 9(8) BINARY VALUE ZERO.                  
021600     05  OUTREC-COUNT        PIC 9(8) BINARY VALUE ZERO.                  
021700     05  AFPREBLK-AFP-IN-STATUS  PIC 99   VALUE ZERO.                     
021800         88  AFPREBLK-AFP-IN-OK  VALUE 00.                                
021900         88  AFPREBLK-AFP-IN-EOF VALUE 47.                                
022000     05  AFPREBLK-AFP-OUT-STATUS PIC 99   VALUE ZERO.                     
022100         88  AFPREBLK-AFP-OUT-OK VALUE 00.                                
022200     05  AFPREBLK-AFP-PRT-STATUS PIC 99   VALUE ZERO.                     
022300         88  AFPREBLK-AFP-PRT-OK VALUE 00.                                
022400     05  AFPREBLK-PC-IN-STATUS   PIC 99   VALUE ZERO.                     
022500         88  AFPREBLK-PC-IN-OK   VALUE 00.                                
022600         88  AFPREBLK-PC-IN-EOF VALUE 47.                                 
022700     05  AFPREBLK-PC-OUT-STATUS PIC 99    VALUE ZERO.                     
022800         88  AFPREBLK-PC-OUT-OK VALUE 00.                                 
022900     05  AFPREBLK-AFP-EOF-FLAG   PIC X    VALUE LOW-VALUE.                
023000         88  AFPREBLK-AFP-EOF    VALUE HIGH-VALUE.                        
023100         88  AFPREBLK-AFP-NOTEOF VALUE LOW-VALUE.                         
023200     05  AFPREBLK-PC-EOF-FLAG    PIC X    VALUE LOW-VALUE.                
023300         88  AFPREBLK-PC-EOF     VALUE HIGH-VALUE.                        
023400     SKIP1                                                                
023500 01  DATE-DATA.                                                           
023600   05  RUN-DATE.                                                          
023700     10 RUN-YY                 PIC 99.                                    
023800     10 RUN-MM                 PIC 99.                                    
023900     10 RUN-DD                 PIC 99.                                    
024000   05  COMPILE-DATE.                                                      
024100     10  COMP-DATE             PIC X(8).                                  
024200     10  COMP-TIME             PIC X(12).                                 
024300   05  RUN-TIME.                                                          
024400     10  RUN-HH                PIC 99.                                    
024500     10  RUN-MM                PIC 99.                                    
024600     10  RUN-SS                PIC 99.                                    
024700     10  RUN-MS                PIC 99.                                    
024800     SKIP2                                                                
024900 01  BINARY-NUMBERS.                                                      
025000     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.              
025100     05  BIN4-X                  REDEFINES BIN-4                          
025200                                 PIC X(4).                                
025300     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.              
025400     05  BIN2-X                  REDEFINES BIN2.                          
025500         10  FILLER              PIC X.                                   
025600         10  BIN2-2              PIC X.                                   
025700     SKIP1                                                                
025800 01  CURREC-STRING               GLOBAL.                                  
025900         05  CURREC-LENGTH               PIC 9(4) BINARY.                 
026000         05  CURREC                      PIC X(32756).                    
026100     SKIP2                                                                
026200 01  GLOBAL-CONSTANTS            GLOBAL.                                  
026300     05  AFPDS-CC            PIC X VALUE X'5A'.                           
026400     05  MODCA-CLASS         PIC X VALUE X'D3'.                           
026500     SKIP3                                                                
026600 01  AFPREBLK-AFP-RECORD            GLOBAL.                               
026700     05  AFPREBLK-REC               OCCURS 32752,                         
026800                                    DEPENDING ON AFPREBLK-LENGTH,         
026900                                    INDEXED BY AFPREBLK-REC-INDX,         
027000                                    PIC X.                                
027100     SKIP3                                                                
027200* STRUCTURED FIELD DEFINITIONS. Used if validating AFP records.           
027300*    COPY STRFLDS SUPPRESS.                                               
027400     eject                                                                
027500 LINKAGE SECTION.                                                         
027600 01  CONTROL-PARMS.                                                       
027700     05  PARM-LENGTH  PIC 9(4) BINARY.                                    
027800     05  PARM-CONVT  PIC X(6).                                            
027900         88  AFP2PC          VALUE 'AFP2PC'.                              
028000         88  PC2AFP          VALUE 'PC2AFP'.                              
028100         88  PC2PRT          VALUE 'PC2PRT'.                              
028200 TITLE 'INITIALIZATION AND MAIN LINE'.                                    
028300 PROCEDURE DIVISION USING CONTROL-PARMS.                                  
028400 000-MAINLINE.                                                            
028500     MOVE WHEN-COMPILED TO COMPILE-DATE.                                  
028600     ACCEPT RUN-DATE FROM DATE.                                           
028700     ACCEPT RUN-TIME FROM TIME.                                           
028800        SKIP2                                                             
028900     IF NOT (AFP2PC OR PC2AFP OR PC2PRT)                                  
029000      THEN                                                                
029100       DISPLAY PGMNAME, ' INVALID EXECUTION PARM.';                       
029200       DISPLAY PGMNAME, ' MUST BE AFP2PC, PC2AFP OR PC2PRT';              
029300       MOVE 8 TO RETURN-CODE;                                             
029400       GOBACK;                                                            
029500     END-IF.                                                              
029600     IF AFP2PC                                                            
029700      THEN                                                                
029800       PERFORM 100-AFP2PC;                                                
029900      ELSE                                                                
030000       PERFORM 200-PC2AFP;                                                
030100     END-IF.                                                              
030200     GOBACK.                                                              
030300 TITLE 'AFP2PC-REBLOCK TO 80 BYTE CHUNKS'.                                
030400  100-AFP2PC.                                                             
030500* Variable-length AFPDS records are blocked into fixed-length             
030600* blocks to simplify transmission from VSE to other systems.              
030700* For PC/AIX systems, if the file is transmitted in binary                
030800* format no further processing need be performed. For host                
030900* systems, the file must be processed either by the AFRREBLK              
031000* exec or this program to reconstitute the AFPDS records.                 
031100     OPEN INPUT AFPREBLK-AFP-IN.                                          
031200     IF NOT AFPREBLK-AFP-IN-OK                                            
031300      THEN                                                                
031400       DISPLAY PGMNAME, ' ERROR OPENING PC INPUT FILE';                   
031500       DISPLAY PGMNAME, ' STATUS CODE ', AFPREBLK-AFP-IN-STATUS;          
031600       MOVE 8 TO RETURN-CODE;                                             
031700       GOBACK;                                                            
031800     END-IF.                                                              
031900     OPEN OUTPUT AFPREBLK-PC-OUT.                                         
032000     IF NOT AFPREBLK-PC-OUT-OK                                            
032100      THEN                                                                
032200       DISPLAY PGMNAME, ' ERROR OPENING AFPDS OUTPUT FILE';               
032300       DISPLAY PGMNAME, ' STATUS CODE ', AFPREBLK-PC-OUT-STATUS;          
032400       MOVE 8 TO RETURN-CODE;                                             
032500       GOBACK;                                                            
032600     END-IF.                                                              
032700     PERFORM 110-GET-AFP-IN.                                              
032800     MOVE SPACES TO CURREC.                                               
032900     MOVE ZERO TO CURREC-LENGTH.                                          
033000     PERFORM WITH TEST BEFORE UNTIL AFPREBLK-AFP-EOF;                     
033100      PERFORM 120-REBLOCK;                                                
033200      PERFORM 130-PUTREC;                                                 
033300     END-PERFORM.                                                         
033400     DISPLAY PGMNAME, ' AFPDS RECORDS READ: ', INREC-COUNT.               
033500     DISPLAY PGMNAME, ' REBLOCKED RECORDS WRITTEN: ', OUTREC-COUNT.       
033600     CLOSE AFPREBLK-AFP-IN,                                               
033700           AFPREBLK-PC-OUT;                                               
033800     GOBACK.                                                              
033900     SKIP2                                                                
034000 110-GET-AFP-IN.                                                          
034100* read a blocked AFPDS record into the input buffer.                      
034200     READ AFPREBLK-AFP-IN,                                                
034300      AT END                                                              
034400       SET AFPREBLK-AFP-EOF TO TRUE;                                      
034500      NOT AT END                                                          
034600       IF NOT AFPREBLK-AFP-OUT-OK                                         
034700        THEN                                                              
034800         DISPLAY PGMNAME, ' I/O ERROR ON AFPPCIN';                        
034900         DISPLAY PGMNAME, ' FILE STATUS ', AFPREBLK-AFP-OUT-STATUS;       
035000         SET AFPREBLK-AFP-EOF TO TRUE;                                    
035100        ELSE                                                              
035200         ADD 1 TO INREC-COUNT;                                            
035300       END-IF;                                                            
035400     END-READ.                                                            
035500     SKIP2                                                                
035600* Records are read from the variable-length AFPDS file and                
035700* accumulated in a buffer until enough bytes are available                
035800* to fill the fixed-length output buffer, which is then                   
035900* written.                                                                
036000 120-REBLOCK.                                                             
036100     IF CURREC-LENGTH < 1                                                 
036200      THEN                                                                
036300       MOVE AFPREBLK-AFP-IN-RECORD TO CURREC;                             
036400       MOVE AFPREBLK-LENGTH TO CURREC-LENGTH;                             
036500       PERFORM 110-GET-AFP-IN;                                            
036600     END-IF.                                                              
036700     IF AFPREBLK-AFP-EOF AND CURREC-LENGTH < 1                            
036800      THEN                                                                
036900       MOVE ZERO TO CURREC-LENGTH;                                        
037000      ELSE                                                                
037100       SET AFPREBLK-AFP-NOTEOF TO TRUE;                                   
037200     END-IF.                                                              
037300     PERFORM WITH TEST BEFORE                                             
037400             UNTIL MAXBUF <= CURREC-LENGTH OR                             
037500                   AFPREBLK-AFP-EOF;                                      
037600       MOVE AFPREBLK-AFP-IN-RECORD TO                                     
037700            CURREC (CURREC-LENGTH  + 1 : AFPREBLK-LENGTH);                
037800       ADD AFPREBLK-LENGTH TO CURREC-LENGTH;                              
037900       PERFORM 110-GET-AFP-IN;                                            
038000     END-PERFORM.                                                         
038100     IF MAXBUF < CURREC-LENGTH                                            
038200      THEN                                                                
038300       MOVE MAXBUF TO BUFMAX;                                             
038400      ELSE                                                                
038500       MOVE CURREC-LENGTH TO BUFMAX;                                      
038600     END-IF.                                                              
038700     MOVE CURREC (1 : BUFMAX) TO AFPREBLK-PC-OUT-RECORD.                  
038800     MOVE CURREC (BUFMAX + 1 :) TO CURREC.                                
038900     COMPUTE CURREC-LENGTH = CURREC-LENGTH - BUFMAX.                      
039000     SKIP2                                                                
039100 130-PUTREC.                                                              
039200     WRITE AFPREBLK-PC-OUT-RECORD.                                        
039300     IF NOT AFPREBLK-PC-OUT-OK                                            
039400      THEN                                                                
039500       DISPLAY PGMNAME, ' I/O ERROR ON AFPVBOT.',                         
039600               ' FILE STATUS ', AFPREBLK-PC-OUT-STATUS;                   
039700       MOVE 12 TO RETURN-CODE;                                            
039800       GOBACK;                                                            
039900      ELSE                                                                
040000       ADD 1 TO OUTREC-COUNT;                                             
040100     END-IF.                                                              
040200 TITLE 'PC2AFP-DEBLOCK TO AFPDS'.                                         
040300 200-PC2AFP.                                                              
040400* The method for deblocking is taken from the AFPDSFIX exec               
040500* from IBM Canada.                                                        
040600     OPEN INPUT AFPREBLK-PC-IN.                                           
040700     IF NOT AFPREBLK-PC-IN-OK                                             
040800      THEN                                                                
040900       DISPLAY PGMNAME, ' ERROR OPENING PC INPUT FILE';                   
041000       DISPLAY PGMNAME, ' STATUS CODE ', AFPREBLK-PC-IN-STATUS;           
041100       MOVE 8 TO RETURN-CODE;                                             
041200       GOBACK;                                                            
041300     END-IF.                                                              
041400     IF PC2AFP                                                            
041500      THEN                                                                
041600       OPEN OUTPUT AFPREBLK-AFP-OUT;                                      
041700       IF NOT AFPREBLK-AFP-OUT-OK                                         
041800        THEN                                                              
041900         DISPLAY PGMNAME, ' ERROR OPENING AFPDS OUTPUT FILE';             
042000         DISPLAY PGMNAME, ' STATUS CODE ',                                
042100                 AFPREBLK-AFP-OUT-STATUS;                                 
042200         MOVE 8 TO RETURN-CODE;                                           
042300         GOBACK;                                                          
042400       END-IF;                                                            
042500      ELSE                                                                
042600       OPEN OUTPUT AFPREBLK-AFP-PRT;                                      
042700       IF NOT AFPREBLK-AFP-PRT-OK                                         
042800        THEN                                                              
042900         DISPLAY PGMNAME, ' ERROR OPENING PRINT OUTPUT FILE';             
043000         DISPLAY PGMNAME, ' STATUS CODE ',                                
043100                 AFPREBLK-AFP-PRT-STATUS;                                 
043200         MOVE 8 TO RETURN-CODE;                                           
043300         GOBACK;                                                          
043400       END-IF;                                                            
043500     END-IF.                                                              
043600     CALL GET-PC-IN.                                                      
043700     MOVE SPACES TO CURREC.                                               
043800     MOVE ZERO TO CURREC-LENGTH.                                          
043900     PERFORM WITH TEST AFTER UNTIL AFPREBLK-PC-EOF AND                    
044000                                   CURREC-LENGTH < 1;                     
044100       CALL GET-OUTREC;                                                   
044200       IF AFPREBLK-LENGTH > 0                                             
044300        THEN                                                              
044400         PERFORM 230-WRITE-OUTREC;                                        
044500       END-IF;                                                            
044600     END-PERFORM.                                                         
044700     DISPLAY PGMNAME, ' BLOCKED RECORDS READ: ', INREC-COUNT.             
044800     DISPLAY PGMNAME, ' DEBLOCKED RECORDS WRITTEN: ', OUTREC-COUNT.       
044900     CLOSE AFPREBLK-PC-IN.                                                
045000     IF PC2AFP                                                            
045100      THEN                                                                
045200       CLOSE AFPREBLK-AFP-OUT;                                            
045300      ELSE                                                                
045400       CLOSE AFPREBLK-AFP-PRT;                                            
045500     END-IF.                                                              
045600     GOBACK.                                                              
045700     SKIP2                                                                
045800 230-WRITE-OUTREC.                                                        
045900     IF PC2AFP                                                            
046000      THEN                                                                
046100       WRITE AFPREBLK-AFP-OUT-RECORD FROM AFPREBLK-AFP-RECORD;            
046200       IF NOT AFPREBLK-AFP-OUT-OK                                         
046300        THEN                                                              
046400         DISPLAY PGMNAME, ' I/O ERROR ON AFPVBOT.',                       
046500                 ' FILE STATUS ', AFPREBLK-AFP-OUT-STATUS;                
046600         MOVE 12 TO RETURN-CODE;                                          
046700         GOBACK;                                                          
046800       END-IF;                                                            
046900      ELSE                                                                
047000* adjust for COBOL adding the CC byte                                     
047010* do not adjust length because implied move starts from 2nd byte. @01a    
047100*      SUBTRACT 1 FROM AFPREBLK-LENGTH;                           @01a    
047200       WRITE AFPREBLK-AFP-PRT-RECORD FROM                                 
047300             AFPREBLK-AFP-RECORD (2:) AFTER ADVANCING AFP-5A;             
047400       IF NOT AFPREBLK-AFP-PRT-OK                                         
047500        THEN                                                              
047600         DISPLAY PGMNAME, ' I/O ERROR ON SYS005.',                        
047700                 ' FILE STATUS ', AFPREBLK-AFP-PRT-STATUS;                
047800         MOVE 12 TO RETURN-CODE;                                          
047900         GOBACK;                                                          
048000       END-IF;                                                            
048100     END-IF.                                                              
048200     ADD 1 TO OUTREC-COUNT.                                               
048300     SKIP2                                                                
048400 ID DIVISION.                                                             
048500 PROGRAM-ID. GET-OUTREC COMMON.                                           
048600 DATA DIVISION.                                                           
048700 WORKING-STORAGE SECTION.                                                 
048800 77  CANDIDATE-POS   PIC S9(4) BINARY.                                    
048900 77  GET-PC-IN       PIC X(12) VALUE 'GET-PC-IN'.                         
049000 77  FOREVER-FLAG    PIC X VALUE LOW-VALUE.                               
049100     88  FOREVER     VALUE HIGH-VALUE.                                    
049200 77  STRLEN          PIC S9(6) BINARY.                                    
049300 77  NOT-AFP         PIC S9(4) BINARY VALUE -99.                          
049400 77  TEMP-PTR        POINTER.                                             
049500 01  TEMP-STR        PIC X(32756).                                        
049600 01  AFP-RECORD      REDEFINES TEMP-STR.                                  
049700     05  AFP-HEADER.                                                      
049800         10  AFP-CC          PIC X.                                       
049900         10  AFP-LENGTH      PIC 9(4) BINARY.                             
050000         10  AFP-TYPE        PIC XXX.                                     
050100         10  AFP-FLAG        PIC X.                                       
050200         10  AFP-SEA         PIC 9(4) BINARY.                             
050300     05  AFP-DATA            PIC X(32745).                                
050400 PROCEDURE DIVISION.                                                      
050500     IF CURREC-LENGTH < 1                                                 
050600      THEN                                                                
050700       MOVE AFPREBLK-PC-IN-RECORD TO CURREC;                              
050800       MOVE LENGTH OF AFPREBLK-PC-IN-RECORD TO CURREC-LENGTH;             
050900       CALL GET-PC-IN;                                                    
051000     END-IF.                                                              
051100     MOVE ZERO TO CANDIDATE-POS.                                          
051200     PERFORM UNTIL FOREVER                                                
051300      INSPECT CURREC (CANDIDATE-POS : CURREC-LENGTH + 1)                  
051400        TALLYING CANDIDATE-POS FOR CHARACTERS                             
051500        BEFORE AFPDS-CC;                                                  
051600      IF CANDIDATE-POS = ZERO OR                                          
051700         CANDIDATE-POS > CURREC-LENGTH                                    
051800       THEN                                                               
051900* The following assumes that only AFPDS records are to                    
052000* be written. If the input is to be mixed-mode, the                       
052100* commented lines below should be uncommented and                         
052200* the setting of AFPREBLK-LENGTH to 0 removed.                            
052300*       MOVE CURREC-LENGTH TO AFPREBLK-LENGTH;                            
052400*       MOVE CURREC (1 : CURREC-LENGTH) TO                                
052500*            AFPREBLK-AFP-RECORD (1 : AFPREBLK-LENGTH);                   
052600        MOVE ZERO TO AFPREBLK-LENGTH;                                     
052700        MOVE ZERO TO CURREC-LENGTH;                                       
052800        EXIT PROGRAM;                                                     
052900       ELSE                                                               
053000        PERFORM 240-VALIDATE-AFP;                                         
053100        IF STRLEN = NOT-AFP                                               
053200         THEN                                                             
053300          ADD 1 TO CANDIDATE-POS;                                         
053400         ELSE                                                             
053500          PERFORM WITH TEST BEFORE                                        
053600              UNTIL STRLEN <= CURREC-LENGTH;                              
053700            IF AFPREBLK-PC-EOF                                            
053800             THEN                                                         
053900              DISPLAY PGMNAME, ' INCOMPLETE STRUCTURED FIELD ',           
054000                      ' RECORD AT END OF INPUT FILE';                     
054100              MOVE CURREC-LENGTH TO AFPREBLK-LENGTH;                      
054200              MOVE CURREC (1 : CURREC-LENGTH) TO                          
054300                   AFPREBLK-AFP-RECORD (1 : AFPREBLK-LENGTH);             
054400              EXIT PROGRAM;                                               
054500            END-IF;                                                       
054600            MOVE AFPREBLK-PC-IN-RECORD TO                                 
054700                 CURREC (CURREC-LENGTH  + 1 :                             
054800                         LENGTH AFPREBLK-PC-IN-RECORD);                   
054900            ADD LENGTH AFPREBLK-PC-IN-RECORD TO CURREC-LENGTH;            
055000            CALL GET-PC-IN;                                               
055100          END-PERFORM;                                                    
055200          MOVE STRLEN TO AFPREBLK-LENGTH;                                 
055300          MOVE CURREC (1 : STRLEN) TO                                     
055400               AFPREBLK-AFP-RECORD (1 : AFPREBLK-LENGTH);                 
055500          MOVE CURREC (STRLEN + 1 :) TO CURREC;                           
055600          COMPUTE CURREC-LENGTH = CURREC-LENGTH - STRLEN;                 
055700          EXIT PROGRAM;                                                   
055800        END-IF;                                                           
055900      END-IF;                                                             
056000     END-PERFORM.                                                         
056100     SKIP2                                                                
056200 240-VALIDATE-AFP.                                                        
056300* Minimally verify a valid structured field and return its                
056400* length, including the carriage control, or return an error if           
056500* invalid.  Note that MO:DCA type and category are not checked            
056600* so that the program need not be updated for new structured              
056700* field.                                                                  
056800     MOVE CURREC (1 : CURREC-LENGTH) TO                                   
056900          TEMP-STR (1 : CURREC-LENGTH).                                   
057000     MOVE AFPREBLK-PC-IN-RECORD (1 : LENGTH AFPREBLK-PC-IN-RECORD)        
057100          TO TEMP-STR (CURREC-LENGTH + 1 :).                              
057200     IF AFP-CC NOT =  AFPDS-CC                                            
057300      THEN                                                                
057400       MOVE NOT-AFP TO STRLEN.                                            
057500     IF AFP-TYPE (1 : 1) NOT =  MODCA-CLASS                               
057600      THEN                                                                
057700       MOVE NOT-AFP TO STRLEN.                                            
057800     IF STRLEN NOT =  NOT-AFP                                             
057900      THEN                                                                
058000       ADD 1, AFP-LENGTH GIVING STRLEN.                                   
058100 END PROGRAM GET-OUTREC.                                                  
058200     SKIP2                                                                
058300 ID DIVISION.                                                             
058400 PROGRAM-ID. GET-PC-IN  COMMON.                                           
058500 DATA DIVISION.                                                           
058600 WORKING-STORAGE SECTION.                                                 
058700 PROCEDURE DIVISION.                                                      
058800* read a blocked uploaded record into the input buffer.                   
058900     READ AFPREBLK-PC-IN,                                                 
059000      AT END                                                              
059100       SET AFPREBLK-PC-EOF TO TRUE;                                       
059200      NOT AT END                                                          
059300       IF NOT AFPREBLK-PC-IN-OK                                           
059400        THEN                                                              
059500         DISPLAY PGMNAME, ' I/O ERROR ON AFPPCIN';                        
059600         DISPLAY PGMNAME, ' FILE STATUS ', AFPREBLK-PC-IN-STATUS;         
059700         SET AFPREBLK-PC-EOF TO TRUE;                                     
059800        ELSE                                                              
059900         ADD 1 TO INREC-COUNT;                                            
060000       END-IF;                                                            
060100     END-READ.                                                            
060200 END PROGRAM GET-PC-IN.                                                   
060300 END PROGRAM AFPREBLK.                                                    